package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class OpcoesProdutosReceitaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaOpcoesProdutosReceita = By.xpath("//span[text() = 'Opções de Produtos na Receita']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoCampoProduto = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoOpcional = By.xpath("//div[@id=\"NMPRODOPC\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoCarbonatoBario500 = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARBONATO DE BARIO 500G']");
    By produtoOleoGirassol = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE GIRASSOL']");
    By produtoTartarato = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'TARTARATO DE POTASSIO E ANTIMONIO']");

    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluirSelecionados = By.xpath("//div[@class=\"zh-footer-center\"]//span[@class=\"action-icon has-label\"]");
    By excluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoSimMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");

    By abaProdutoPrincipalReceita = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produto Principal da Receita']");
    By abaprodutoOpcionais = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos Opcionais']");
    By codigoProdutoPrincipal = By.xpath("//div[@data-zh-id=\"193032326017965047551355\"]/p");
    By nomeProdutoPrincipal = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]/p");

    By mensagemObrigatorioProdPrinc = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdOp = By.xpath("//div[@data-zh-id=\"193032326027929424611336\"]//div[@class=\"zh-validation\"]/span");

    By checkBoxProdutoOpcional = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]/div[1]/span");
    By codigoProdutoOpcional = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By nomeprodutoOpcional = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]/div[3]/span");

    By checkBoxProdTelaInicial = By.xpath("//div[@id=\"grid-193032326036450896671328\"]//div[@class=\"body-content\"]/div[1]/div[1]/span");
    By oleoGirassolTelaInicial = By.xpath("//div[@class=\"body-content\"]/div[1]//span[text() = 'OLEO DE GIRASSOL']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Opções de Produtos na Receita");
        click(telaOpcoesProdutosReceita);
    }

    public void adicionarProdutoPrincipal() {
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARBONATO DE BARIO 500G");
        click(produtoCarbonatoBario500);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Tabela não pode conter produto de compra.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após tentar adicionar um produto de compra");
        click(botaoOk);

        click(botaoCampoProduto);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "OLEO DE GIRASSOL");
        click(produtoOleoGirassol);
        click(botaoSalvar);
    }

    public void verificarprodutoPrincAdd() {
        tempo();
        click(abaProdutoPrincipalReceita);
        tempo();

        //valores esperados
        String expCodigo = "0.22.5.0.00.000";
        String expnome = "OLEO DE GIRASSOL";

        //valores encontrados
        String encCodigo = getText(codigoProdutoPrincipal);
        String encNome = getText(nomeProdutoPrincipal);

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do produto principal adicionado");
        Assert.assertEquals(encNome, expnome, "Verificação do nome do produto principal adicionado");
    }

    public void adicionarProdutoOpcional() {
        click(abaprodutoOpcionais);
        click(botaoAdicionar);
        click(botaoCampoProdutoOpcional);
        sendKeys(campoProcurar, "TARTARATO DE POTASSIO E ANTIMONIO");
        click(produtoTartarato);
        click(botaoSalvar);
        tempo();
        tempo();
    }

    public void verificarProdutoOpcionaAdd() {
        //valores esperados
        String expCodigo = "1.01.1.1.02.023.00";
        String expNome = "TARTARATO DE POTASSIO E ANTIMONIO";

        //valores encontrados
        String encCodigo = getText(codigoProdutoOpcional);
        String encNome = getText(nomeprodutoOpcional);
        Assert.assertEquals(encCodigo, expCodigo, "Verificação código produto opcional adicionado");
        Assert.assertEquals(encNome, expNome, "Verificação código nome opcional adicionado");
    }

    public void excluirProdutoOpcional() {
        click(checkBoxProdutoOpcional);
        click(botaoExcluirSelecionados);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exbida após solicitar a exclusão do produto opcional");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de excluído com sucesso, do produto opcional");
    }

    public void excluirProdutoPrincipal() {
        tempo();
        click(abaProdutoPrincipalReceita);
        tempo();
        click(excluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de alerta exbida após solicitar exclusão do produto principal da receita.");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de excluído com sucesso, do produto principal");
    }

    public void campoObrigatorioProdPrinc() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String mensagem = getText(mensagemObrigatorioProdPrinc);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo produto da tela, produto principal da receita");
        tempo();
        click(botaoCancelar);
    }

    public void campoObrigatorioProdOp() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String mensagem = getText(mensagemObrigatorioProdOp);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de campo obrigatório do campo produto da tela, produto principal da receita");
    }

    public void excluirPrdTelainicial() {
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
        tempo();
        click(checkBoxProdTelaInicial);
        click(botaoExcluirSelecionados);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de alerta exbida após solicitar exclusão do produto principal da receita.");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de excluído com sucesso, do produto principal pela tela inicial");
    }

}
